const getters = {
    mode(state) {
        return state.mode
    },
    isSale(state) {
        return state.mode === 'sale'
    },
    loading(state) {
        return state.loading
    },
    footerButtonsVisibility(state) {
        return state.footerButtonsVisibility
    },
    settingsVisibility(state) {
        return state.settingsVisibility
    },
    settings(state) {
        let values = {
            imageType: true,
            allowExchange: false,
            viewExchanges: false,
            currencies: []
        }

        if (!state.settings) {
            return values
        }

        values.imageType = state.settings.imageType === 'small'
        values.allowExchange = state.settings.allowCurrencyExchange
        values.viewExchanges = state.settings.viewCurrencyExchanges
        values.currencies = state.settings.currencies

        return values
    },
    result(state) {
        return state.result
    },
    completed(state) {
        return state.completed
    },
    askForPrint(state) {
        return state.askForPrint
    },
    error(state) {
        return state.error
    }
}

export default getters