import Vue from 'vue'
import Vuex from 'vuex'

import state from '@/store/state'
import getters from '@/store/getters'
import mutations from '@/store/mutations'
import actions from '@/store/actions'

import cartModule from '@/store/modules/cart'
import currencyModule from '@/store/modules/currency'
import customerModule from '@/store/modules/customer'
import dateModule from '@/store/modules/date'
import journalModule from '@/store/modules/journal'
import paymentModule from '@/store/modules/payment'
import productModule from '@/store/modules/product'
import userModule from '@/store/modules/user'
import bankModule from '@/store/modules/bank'
import bankPaymentTypeModule from '@/store/modules/bankPaymentType'
import chequeTypeModule from './modules/chequeType'
import storeModule from './modules/store'

Vue.use(Vuex)

const store = new Vuex.Store({
    state,
    getters,
    mutations,
    actions,
    modules: {
        cartModule,
        currencyModule,
        customerModule,
        dateModule,
        journalModule,
        paymentModule,
        productModule,
        userModule,
        bankModule,
        bankPaymentTypeModule,
        chequeTypeModule,
        storeModule
    },
    strict: true
})

export default store
