const state = {
    loadingChequeTypes: false,
    chequeTypes: [],
    selectedChequeType: 0
}

const getters = {
    loadingChequeTypes(state) {
        return state.loadingChequeTypes
    },
    chequeTypes(state) {
        return state.chequeTypes
    },
    selectedChequeType(state) {
        return state.selectedChequeType
    }
}

const mutations = {
    setLoadingChequeTypes(state, loading) {
        state.loadingChequeTypes = !!loading
    },
    setChequeTypes(state, chequeTypes) {
        state.chequeTypes = chequeTypes
    },
    setSelectedChequeType(state, id) {
        if (id) {
            state.selectedChequeType = state.chequeTypes.find(c => c.id === id)
            return
        }

        if (state.chequeTypes.length > 0) {
            state.selectedChequeType = state.chequeTypes[0]
            return
        }

        state.selectedChequeType = null
    }
}

const actions = {
    initChequeTypes({ commit}, chequeTypes) {
        commit('setChequeTypes', chequeTypes)
        commit('setSelectedChequeType')
        commit('setLoadingChequeTypes')
    },
    changeChequeType({ commit }, id) {
        commit('setSelectedChequeType', id)
    },
    resetChequeType({ commit }) {
        commit('setLoadingChequeTypes')
        commit('setChequeTypes', [])
        commit('setSelectedChequeType')
    }
}

export default {
    state,
    getters,
    actions,
    mutations
}